package restx.apidocs;

import com.google.common.collect.ImmutableSet;
import restx.factory.*;
import restx.apidocs.ApiDeclarationRoute;

@Machine
public class ApiDeclarationRouteFactoryMachine extends SingleNameFactoryMachine<ApiDeclarationRoute> {
    public static final Name<ApiDeclarationRoute> NAME = Name.of(ApiDeclarationRoute.class, "ApiDeclarationRoute");

    public ApiDeclarationRouteFactoryMachine() {
        super(0, new StdMachineEngine<ApiDeclarationRoute>(NAME, BoundlessComponentBox.FACTORY) {
private final Factory.Query<com.fasterxml.jackson.databind.ObjectMapper> mapper = Factory.Query.byName(Name.of(com.fasterxml.jackson.databind.ObjectMapper.class, "FrontObjectMapper"));
private final Factory.Query<restx.factory.Factory> factory = Factory.Query.byClass(restx.factory.Factory.class).mandatory();

            @Override
            public BillOfMaterials getBillOfMaterial() {
                return new BillOfMaterials(ImmutableSet.<Factory.Query<?>>of(
mapper,
factory
                ));
            }

            @Override
            protected ApiDeclarationRoute doNewComponent(SatisfiedBOM satisfiedBOM) {
                return new ApiDeclarationRoute(
satisfiedBOM.getOne(mapper).get().getComponent(),
satisfiedBOM.getOne(factory).get().getComponent()
                );
            }
        });
    }

}
