package restx.apidocs;

import com.google.common.collect.ImmutableSet;
import restx.factory.*;
import restx.apidocs.ApiDocsIndexRoute;

@Machine
public class ApiDocsIndexRouteFactoryMachine extends SingleNameFactoryMachine<ApiDocsIndexRoute> {
    public static final Name<ApiDocsIndexRoute> NAME = Name.of(ApiDocsIndexRoute.class, "ApiDocsIndexRoute");

    public ApiDocsIndexRouteFactoryMachine() {
        super(0, new StdMachineEngine<ApiDocsIndexRoute>(NAME, BoundlessComponentBox.FACTORY) {
private final Factory.Query<com.fasterxml.jackson.databind.ObjectMapper> mapper = Factory.Query.byName(Name.of(com.fasterxml.jackson.databind.ObjectMapper.class, "FrontObjectMapper"));
private final Factory.Query<restx.factory.Factory> factory = Factory.Query.byClass(restx.factory.Factory.class).mandatory();

            @Override
            public BillOfMaterials getBillOfMaterial() {
                return new BillOfMaterials(ImmutableSet.<Factory.Query<?>>of(
mapper,
factory
                ));
            }

            @Override
            protected ApiDocsIndexRoute doNewComponent(SatisfiedBOM satisfiedBOM) {
                return new ApiDocsIndexRoute(
satisfiedBOM.getOne(mapper).get().getComponent(),
satisfiedBOM.getOne(factory).get().getComponent()
                );
            }
        });
    }

}
