package restx.apidocs;

import com.google.common.collect.ImmutableSet;
import restx.factory.*;
import restx.apidocs.SpecsResource;

@Machine
public class SpecsResourceFactoryMachine extends SingleNameFactoryMachine<SpecsResource> {
    public static final Name<SpecsResource> NAME = Name.of(SpecsResource.class, "SpecsResource");

    public SpecsResourceFactoryMachine() {
        super(0, new StdMachineEngine<SpecsResource>(NAME, BoundlessComponentBox.FACTORY) {
private final Factory.Query<restx.specs.RestxSpecRepository> repository = Factory.Query.byClass(restx.specs.RestxSpecRepository.class).mandatory();

            @Override
            public BillOfMaterials getBillOfMaterial() {
                return new BillOfMaterials(ImmutableSet.<Factory.Query<?>>of(
repository
                ));
            }

            @Override
            protected SpecsResource doNewComponent(SatisfiedBOM satisfiedBOM) {
                return new SpecsResource(
satisfiedBOM.getOne(repository).get().getComponent()
                );
            }
        });
    }

}
