package restx.apidocs;

import com.google.common.collect.ImmutableSet;
import restx.factory.*;
import restx.apidocs.SpecsResourceRouter;

@Machine
public class SpecsResourceRouterFactoryMachine extends SingleNameFactoryMachine<SpecsResourceRouter> {
    public static final Name<SpecsResourceRouter> NAME = Name.of(SpecsResourceRouter.class, "SpecsResourceRouter");

    public SpecsResourceRouterFactoryMachine() {
        super(0, new StdMachineEngine<SpecsResourceRouter>(NAME, BoundlessComponentBox.FACTORY) {
private final Factory.Query<restx.apidocs.SpecsResource> resource = Factory.Query.byClass(restx.apidocs.SpecsResource.class).mandatory();
private final Factory.Query<com.fasterxml.jackson.databind.ObjectMapper> mapper = Factory.Query.byClass(com.fasterxml.jackson.databind.ObjectMapper.class).mandatory();
private final Factory.Query<restx.converters.MainStringConverter> converter = Factory.Query.byClass(restx.converters.MainStringConverter.class).mandatory();
private final Factory.Query<javax.validation.Validator> validator = Factory.Query.byClass(javax.validation.Validator.class).mandatory();

            @Override
            public BillOfMaterials getBillOfMaterial() {
                return new BillOfMaterials(ImmutableSet.<Factory.Query<?>>of(
resource,
mapper,
converter,
validator
                ));
            }

            @Override
            protected SpecsResourceRouter doNewComponent(SatisfiedBOM satisfiedBOM) {
                return new SpecsResourceRouter(
satisfiedBOM.getOne(resource).get().getComponent(),
satisfiedBOM.getOne(mapper).get().getComponent(),
satisfiedBOM.getOne(converter).get().getComponent(),
satisfiedBOM.getOne(validator).get().getComponent()
                );
            }
        });
    }

}
